Prime Path (POJ - 3126) (BFS)

题目描述:
The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input
3
1033 8179
1373 8017
1033 1033
Sample Output
6
7
0
大致意思是给你两个素数x和y,且都是4位数
x变换到y的步骤是每次只改变x的一个数字,且这个过度状态下的数也必须满足是4位的素质,问最少需要几步。

用宽搜的两个条件是,一个是存在路径,二十求的是最值或者是打印路径。
所以大致确定是用宽搜,即使这道题打印路径也不会很难
那么我们需要确定一个状态(题目里是表示一个素数)如何转移到另一个状态,这个不难,就比如 初始状态1033,对第一位有9种其他的数可以替换,其他位也是,所以总共有4*9=36种状态转移方向,但是是否满足一个合法转移,需要两个条件,这个数是4位素数,并且在这个前提下,这个素数之前并没有访问过。

问题不是很难,但是需要耐心,代码打着打着就非常长了,(上面还有很多细节没有涉及,如何判断素数,这需要打素数表)
代码:

import java.util.ArrayList;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.Queue;
import java.util.Scanner;

public class Main
{   
    static int vv[];
    public static void main(String[] args) 
    {
        ArrayList<Integer> list=new ArrayList<Integer>();
        HashSet<Integer>set=new HashSet<Integer>();
        int num=2;
        int p=1;
        boolean sign;
        while(num<9999)//找出10000以内的素数
        {
            if(p*p<num)p++;
            sign=true;
            for(int i=0;i<list.size()&&list.get(i)<=p;i++)
            {
                if(num%list.get(i)==0)
                {
                    sign=false;
                    break;
                }
            }
            if(sign)
            {
                list.add(num);
                if(num>=1000)//我们只要大于1000的素数,加入hax表用于判断
                    set.add(num);
            }
            num++;
        }//前期工作完成

        Scanner sc=new Scanner(System.in);
        int n=sc.nextInt();
        while((n--)>0)
        {
            int x=sc.nextInt();//开始状态
            int y=sc.nextInt();//结束状态
            if(x==y)//相等直接输出
            {
                System.out.println(0);
                continue;
            }
            vv=new int[10000];//判断这个数(状态)是否访问过,置1说明访问过了
            Queue<node>queue =new LinkedList<node>();
            queue.add(new node(x,0));//初始状态
            vv[x]=1;
            int ans=0;
            boolean sign1=true;//为true表示没有找到
            while(!queue.isEmpty()&&sign1)
            {
                node t=queue.poll();//出队
                int k=t.s;
                int a[]=new int[4];
                int g=1000;
                for(int i=0;i<=3;i++)//这一步是把这个素质分解成各个位上的4个数,以方便下面的枚举
                {
                    a[i]=k/g;
                    k=k%g;
                    g/=10;
                }
                int h;
                boolean sign2=false;
                for(int i=0;i<=3;i++)//考录每个位数
                {
                    if(sign2)break;
                    h=a[i];//把原先的数保存起来
                    for(int j=0;j<=9;j++)//每个位上的数只能0到9,有人说千位上不能为0,没关系,假设这个三位数是素数,这个数也不会出现在set中,然后状态是自己本身怎么办,都没关系,因为下面的if判断绝对通不过(对状态的转移尽量统一化,尽量少管特殊情况,除非万不得已)
                    {
                        a[i]=j;
                        int getT=get(a);//改变了以后转化为一个数
                        if(!set.contains(getT)||vv[getT]==1)//判断先如果不在set中,或者在set中,且之前有访问过跳过
                            continue;
                        if(getT==y)//一旦找到
                        {
                            sign1=false;//退出while循环
                            sign2=true;//退出嵌套的for循环
                            ans=t.m+1;//把答案转移到ans
                            break;
                        }
                        else//没有找到,就加入队列,
                        {
                            queue.add(new node(getT,t.m+1));
                            vv[getT]=1;//说明访问过了
                        }
                    }
                    a[i]=h;//,所有可能都枚举完了,还原之前的数
                }
            }
            System.out.println(ans);
        }
    }
    static int get(int a[] )//四个数转化成一个数
    {
        int s=0;
        for(int i=0;i<4;i++)
            s=(s*10+a[i]);
        return s;
    }
}
class node
{
    int s;
    int m;//在转移到这个状态时,已经走过的步数
    node(int s,int m)
    {
        this.s=s;
        this.m=m;
    }
}
  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值